Index: /palm/trunk/SOURCE/basic_constants_and_equations_mod.f90
===================================================================
--- /palm/trunk/SOURCE/basic_constants_and_equations_mod.f90	(revision 4399)
+++ /palm/trunk/SOURCE/basic_constants_and_equations_mod.f90	(revision 4400)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Move routine to transform coordinates from netcdf_interface_mod to 
+! basic_constants_and_equations_mod
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -113,4 +117,9 @@
             barometric_formula_1d
 
+
+    INTERFACE convert_utm_to_geographic
+       MODULE PROCEDURE convert_utm_to_geographic
+    END INTERFACE convert_utm_to_geographic
+
     INTERFACE magnus
        MODULE PROCEDURE magnus_0d
@@ -142,6 +151,146 @@
        MODULE PROCEDURE barometric_formula_1d
     END INTERFACE barometric_formula
+!
+!-- Public routines
+    PUBLIC convert_utm_to_geographic
 
  CONTAINS
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Convert UTM coordinates into geographic latitude and longitude. Conversion
+!> is based on the work of KrÃŒger (1912) DOI: 10.2312/GFZ.b103-krueger28
+!> and Karney (2013) DOI: 10.1007/s00190-012-0578-z
+!> Based on a JavaScript of the geodesy function library written by chrisveness
+!> https://github.com/chrisveness/geodesy
+!------------------------------------------------------------------------------!
+    SUBROUTINE convert_utm_to_geographic( crs, eutm, nutm, lon, lat )
+
+       INTEGER(iwp) ::  j   !< loop index
+
+       REAL(wp), INTENT(in)  ::  eutm !< easting (UTM)
+       REAL(wp), INTENT(out) ::  lat  !< geographic latitude in degree
+       REAL(wp), INTENT(out) ::  lon  !< geographic longitude in degree
+       REAL(wp), INTENT(in)  ::  nutm !< northing (UTM)
+
+       REAL(wp) ::  a           !< 2*pi*a is the circumference of a meridian
+       REAL(wp) ::  cos_eta_s   !< cos(eta_s)
+       REAL(wp) ::  delta_i     !<
+       REAL(wp) ::  delta_tau_i !<
+       REAL(wp) ::  e           !< eccentricity
+       REAL(wp) ::  eta         !<
+       REAL(wp) ::  eta_s       !<
+       REAL(wp) ::  n           !< 3rd flattening
+       REAL(wp) ::  n2          !< n^2
+       REAL(wp) ::  n3          !< n^3
+       REAL(wp) ::  n4          !< n^4
+       REAL(wp) ::  n5          !< n^5
+       REAL(wp) ::  n6          !< n^6
+       REAL(wp) ::  nu          !<
+       REAL(wp) ::  nu_s        !<
+       REAL(wp) ::  sin_eta_s   !< sin(eta_s)
+       REAL(wp) ::  sinh_nu_s   !< sinush(nu_s)
+       REAL(wp) ::  tau_i       !<
+       REAL(wp) ::  tau_i_s     !<
+       REAL(wp) ::  tau_s       !<
+       REAL(wp) ::  x           !< adjusted easting
+       REAL(wp) ::  y           !< adjusted northing
+
+       REAL(wp), DIMENSION(6) ::  beta !< 6th order KrÃŒger expressions
+
+       REAL(wp), DIMENSION(8), INTENT(in) ::  crs !< coordinate reference system, consists of
+                                                  !< (/semi_major_axis,
+                                                  !<   inverse_flattening,
+                                                  !<   longitude_of_prime_meridian,
+                                                  !<   longitude_of_central_meridian,
+                                                  !<   scale_factor_at_central_meridian,
+                                                  !<   latitude_of_projection_origin,
+                                                  !<   false_easting,
+                                                  !<   false_northing /)
+
+       x = eutm - crs(7)  ! remove false easting
+       y = nutm - crs(8)  ! remove false northing
+!
+!--    from Karney 2011 Eq 15-22, 36:
+       e = SQRT( 1.0_wp / crs(2) * ( 2.0_wp - 1.0_wp / crs(2) ) )
+       n = 1.0_wp / crs(2) / ( 2.0_wp - 1.0_wp / crs(2) )
+       n2 = n * n
+       n3 = n * n2
+       n4 = n * n3
+       n5 = n * n4
+       n6 = n * n5
+
+       a = crs(1) / ( 1.0_wp + n ) * ( 1.0_wp + 0.25_wp * n2       &
+                                              + 0.015625_wp * n4   &
+                                              + 3.90625E-3_wp * n6 )
+
+       nu  = x / ( crs(5) * a )
+       eta = y / ( crs(5) * a )
+
+!--    According to KrÃŒger (1912), eq. 26*
+       beta(1) =        0.5_wp                  * n  &
+               -        2.0_wp /         3.0_wp * n2 &
+               +       37.0_wp /        96.0_wp * n3 &
+               -        1.0_wp /       360.0_wp * n4 &
+               -       81.0_wp /       512.0_wp * n5 &
+               +    96199.0_wp /    604800.0_wp * n6
+
+       beta(2) =        1.0_wp /        48.0_wp * n2 &
+               +        1.0_wp /        15.0_wp * n3 &
+               -      437.0_wp /      1440.0_wp * n4 &
+               +       46.0_wp /       105.0_wp * n5 &
+               -  1118711.0_wp /   3870720.0_wp * n6
+
+       beta(3) =       17.0_wp /       480.0_wp * n3 &
+               -       37.0_wp /       840.0_wp * n4 &
+               -      209.0_wp /      4480.0_wp * n5 &
+               +     5569.0_wp /     90720.0_wp * n6
+
+       beta(4) =     4397.0_wp /    161280.0_wp * n4 &
+               -       11.0_wp /       504.0_wp * n5 &
+               -   830251.0_wp /   7257600.0_wp * n6
+
+       beta(5) =     4583.0_wp /    161280.0_wp * n5 &
+               -   108847.0_wp /   3991680.0_wp * n6
+
+       beta(6) = 20648693.0_wp / 638668800.0_wp * n6
+
+       eta_s = eta
+       nu_s  = nu
+       DO  j = 1, 6
+         eta_s = eta_s - beta(j) * SIN(2.0_wp * j * eta) * COSH(2.0_wp * j * nu)
+         nu_s  = nu_s  - beta(j) * COS(2.0_wp * j * eta) * SINH(2.0_wp * j * nu)
+       ENDDO
+
+       sinh_nu_s = SINH( nu_s )
+       sin_eta_s = SIN( eta_s )
+       cos_eta_s = COS( eta_s )
+
+       tau_s = sin_eta_s / SQRT( sinh_nu_s**2 + cos_eta_s**2 )
+
+       tau_i = tau_s
+       delta_tau_i = 1.0_wp
+
+       DO WHILE ( ABS( delta_tau_i ) > 1.0E-12_wp )
+
+         delta_i = SINH( e * ATANH( e * tau_i / SQRT( 1.0_wp + tau_i**2 ) ) )
+
+         tau_i_s = tau_i   * SQRT( 1.0_wp + delta_i**2 )  &
+                  - delta_i * SQRT( 1.0_wp + tau_i**2 )
+
+         delta_tau_i = ( tau_s - tau_i_s ) / SQRT( 1.0_wp + tau_i_s**2 )  &
+                      * ( 1.0_wp + ( 1.0_wp - e**2 ) * tau_i**2 )          &
+                      / ( ( 1.0_wp - e**2 ) * SQRT( 1.0_wp + tau_i**2 ) )
+
+         tau_i = tau_i + delta_tau_i
+
+       ENDDO
+
+       lat = ATAN( tau_i ) / pi * 180.0_wp
+       lon = ATAN2( sinh_nu_s, cos_eta_s ) / pi * 180.0_wp + crs(4)
+
+    END SUBROUTINE convert_utm_to_geographic
 
 !------------------------------------------------------------------------------!
@@ -161,5 +310,5 @@
 !--    Saturation vapor pressure for a specific temperature:
        magnus_0d =  611.2_wp * EXP( 17.62_wp * ( t - degc_to_k ) /             &
-                                                   ( t - 29.65_wp  ) )
+                                               ( t - 29.65_wp  ) )
 
     END FUNCTION magnus_0d
Index: /palm/trunk/SOURCE/check_open.f90
===================================================================
--- /palm/trunk/SOURCE/check_open.f90	(revision 4399)
+++ /palm/trunk/SOURCE/check_open.f90	(revision 4400)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Remove binary output for virtual measurements
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -444,37 +447,4 @@
           ENDIF
 
-       CASE ( 27 )
-!
-!--       Binary files for virtual measurement data
-          IF ( myid_char == '' )  THEN
-             OPEN ( 27, FILE='VIRTUAL_MEAS_BIN'//TRIM( coupling_char )//       &
-                             myid_char, FORM='UNFORMATTED', POSITION='APPEND' )
-          ELSE
-
-             IF ( myid == 0  .AND. .NOT. openfile(file_id)%opened_before )  THEN
-                CALL local_system( 'mkdir  VIRTUAL_MEAS_BIN' //                &
-                                   TRIM( coupling_char ) )
-             ENDIF
-#if defined( __parallel )
-!
-!--          Set a barrier in order to allow that all other processors in the 
-!--          directory created by PE0 can open their file
-             CALL MPI_BARRIER( comm2d, ierr )
-#endif
-             ioerr = 1
-             DO WHILE ( ioerr /= 0 )
-                OPEN ( 27, FILE='VIRTUAL_MEAS_BIN'//TRIM(coupling_char)//      &
-                                '/'//myid_char,                                &
-                           FORM='UNFORMATTED', IOSTAT=ioerr )
-                IF ( ioerr /= 0 )  THEN
-                   WRITE( 9, * )  '*** could not open "VIRTUAL_MEAS_BIN'//     &
-                                  TRIM(coupling_char)//'/'//myid_char//        &
-                                  '"! Trying again in 1 sec.'
-                   CALL fortran_sleep( 1 )
-                ENDIF
-             ENDDO
-
-          ENDIF
-
        CASE ( 30 )
 
Index: /palm/trunk/SOURCE/module_interface.f90
===================================================================
--- /palm/trunk/SOURCE/module_interface.f90	(revision 4399)
+++ /palm/trunk/SOURCE/module_interface.f90	(revision 4400)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! - Use data-output module for virtual measurement output
+! - Remove deprecated routines for virtual measurement module
+! 
+! 4361 2020-01-07 12:22:38Z suehring
 ! Remove unused arrays in pmc_rrd_local
 ! 
@@ -172,7 +176,14 @@
     USE kinds
 
+    USE pegrid,                                                                &
+        ONLY:  comm2d
+
 !
 !-- load module-specific control parameters.
 !-- ToDo: move all of them to respective module or a dedicated central module
+    USE data_output_module,                                                    &
+        ONLY:  dom_def_end,                                                    &
+               dom_finalize_output,                                            &
+               dom_init
 
     USE dynamics_mod, &
@@ -220,4 +231,5 @@
         ONLY:  air_chemistry,                                                  &
                biometeorology,                                                 &
+               coupling_char,                                                  &
                debug_output,                                                   &
                debug_output_timestep,                                          &
@@ -493,5 +505,5 @@
         ONLY:  vm_check_parameters,                                            &
                vm_init,                                                        &
-               vm_last_actions,                                                &
+               vm_init_output,                                                 &
                vm_parin
 
@@ -543,4 +555,5 @@
        module_interface_init,                                                  &
        module_interface_init_checks,                                           &
+       module_interface_init_output,                                           &
        module_interface_header,                                                &
        module_interface_actions,                                               &
@@ -600,4 +613,8 @@
        MODULE PROCEDURE module_interface_init_checks
     END INTERFACE module_interface_init_checks
+
+    INTERFACE module_interface_init_output
+       MODULE PROCEDURE module_interface_init_output
+    END INTERFACE module_interface_init_output
 
     INTERFACE module_interface_header
@@ -1081,7 +1098,29 @@
     IF ( debug_output )  CALL debug_message( 'module-specific initialization', 'end' )
 
-
  END SUBROUTINE module_interface_init
 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Initialize data output
+!------------------------------------------------------------------------------!
+ SUBROUTINE module_interface_init_output
+
+    INTEGER(iwp) ::  return_value  !< returned status value of called function
+
+!
+!-- Initialize data-output module
+    CALL dom_init( file_suffix_of_output_group=coupling_char,                  &
+                   mpi_comm_of_output_group=comm2d,                            &
+                   program_debug_output_unit=6,                                &
+                   debug_output=debug_output )
+!
+!-- Define module-specific output quantities
+    IF ( virtual_measurement )  CALL vm_init_output
+!
+!-- Leave output-definition state
+    return_value = dom_def_end()
+
+ END SUBROUTINE module_interface_init_output
 
 !------------------------------------------------------------------------------!
@@ -1890,11 +1929,13 @@
  SUBROUTINE module_interface_last_actions
 
+    INTEGER ::  return_value  !< returned status value of a called function
+
 
     IF ( debug_output )  CALL debug_message( 'module-specific last actions', 'start' )
 
+    return_value = dom_finalize_output()
+
     CALL dynamics_last_actions
 
-    IF ( virtual_measurement )  CALL vm_last_actions
-
     IF ( user_module_enabled )  CALL user_last_actions
 
Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 4399)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 4400)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! - Routine to inquire default fill values added
+! - netcdf_data_input_att and netcdf_data_input_var routines removed
+! 
+! 4392 2020-01-31 16:14:57Z pavelkrc
 ! (resler) Decrease length of reading buffer (fix problem of ifort/icc compilers)
 ! 
@@ -542,4 +546,5 @@
        INTEGER(iwp) ::  version              !< version of data set
 
+       REAL(wp) ::  fillvalue = -9999.0      !< default fill value
        REAL(wp) ::  origin_lat               !< latitude of lower left corner
        REAL(wp) ::  origin_lon               !< longitude of lower left corner
@@ -652,4 +657,6 @@
     LOGICAL ::  collective_read = .FALSE.      !< Enable NetCDF collective read
 
+    REAL(wp), DIMENSION(8) ::  crs_list        !< list of coord_ref_sys values
+
     TYPE(global_atts_type) ::  input_file_atts !< global attributes of input file
 
@@ -666,11 +673,16 @@
     END INTERFACE netcdf_data_input_check_static
 
-    INTERFACE netcdf_data_input_chemistry_data                        
+    INTERFACE netcdf_data_input_chemistry_data
        MODULE PROCEDURE netcdf_data_input_chemistry_data
     END INTERFACE netcdf_data_input_chemistry_data
-    
-    INTERFACE get_dimension_length                        
+
+    INTERFACE get_dimension_length
        MODULE PROCEDURE get_dimension_length
     END INTERFACE get_dimension_length
+
+    INTERFACE inquire_fill_value
+       MODULE PROCEDURE inquire_fill_value_int
+       MODULE PROCEDURE inquire_fill_value_real
+    END INTERFACE inquire_fill_value
 
     INTERFACE netcdf_data_input_inquire_file
@@ -681,11 +693,4 @@
        MODULE PROCEDURE netcdf_data_input_init
     END INTERFACE netcdf_data_input_init
-    
-    INTERFACE netcdf_data_input_att
-       MODULE PROCEDURE netcdf_data_input_att_int8
-       MODULE PROCEDURE netcdf_data_input_att_int32
-       MODULE PROCEDURE netcdf_data_input_att_real
-       MODULE PROCEDURE netcdf_data_input_att_string
-    END INTERFACE netcdf_data_input_att
 
     INTERFACE netcdf_data_input_init_3d
@@ -696,10 +701,4 @@
        MODULE PROCEDURE netcdf_data_input_surface_data
     END INTERFACE netcdf_data_input_surface_data
-
-    INTERFACE netcdf_data_input_var
-       MODULE PROCEDURE netcdf_data_input_var_char
-       MODULE PROCEDURE netcdf_data_input_var_real_1d
-       MODULE PROCEDURE netcdf_data_input_var_real_2d
-    END INTERFACE netcdf_data_input_var
 
     INTERFACE netcdf_data_input_uvem
@@ -752,4 +751,5 @@
            chem_emis, chem_emis_att, chem_emis_att_type, chem_emis_val_type,   &
            coord_ref_sys,                                                      &
+           crs_list,                                                           &
            init_3d, init_model, input_file_atts,                               &
            input_file_dynamic,                                                 &
@@ -781,8 +781,6 @@
            netcdf_data_input_init,                                             &
            netcdf_data_input_init_3d,                                          &
-           netcdf_data_input_att,                                              &
            netcdf_data_input_surface_data,                                     &
            netcdf_data_input_topo,                                             &
-           netcdf_data_input_var,                                              &
            get_attribute,                                                      &
            get_variable,                                                       &
@@ -790,4 +788,5 @@
            open_read_file,                                                     &
            check_existence,                                                    &
+           inquire_fill_value,                                                 &
            inquire_num_variables,                                              &
            inquire_variable_names,                                             &
@@ -817,5 +816,5 @@
        INQUIRE( FILE = TRIM( input_file_chem )    // TRIM( coupling_char ),    &
                 EXIST = input_pids_chem )
-       INQUIRE( FILE = TRIM( input_file_uvem ) // TRIM( coupling_char ),       &
+       INQUIRE( FILE = TRIM( input_file_uvem )    // TRIM( coupling_char ),    &
                 EXIST = input_pids_uvem  )
        INQUIRE( FILE = TRIM( input_file_vm )      // TRIM( coupling_char ),    &
@@ -962,5 +961,16 @@
        init_model%origin_z        = input_file_atts%origin_z  
        init_model%rotation_angle  = input_file_atts%rotation_angle  
-            
+
+!
+!--    Define list of crs attributes. This is required for coordinate 
+!--    transformation. 
+       crs_list = (/ coord_ref_sys%semi_major_axis,                            &
+                     coord_ref_sys%inverse_flattening,                         &
+                     coord_ref_sys%longitude_of_prime_meridian,                &
+                     coord_ref_sys%longitude_of_central_meridian,              &
+                     coord_ref_sys%scale_factor_at_central_meridian,           &
+                     coord_ref_sys%latitude_of_projection_origin,              &
+                     coord_ref_sys%false_easting,                              &
+                     coord_ref_sys%false_northing /)
 !
 !--    In case of nested runs, each model domain might have different longitude
@@ -977,258 +987,5 @@
 
     END SUBROUTINE netcdf_data_input_init
-    
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Read an array of characters.
-!------------------------------------------------------------------------------!
-    SUBROUTINE netcdf_data_input_var_char( val, search_string, id_mod )
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*) ::  search_string     !< name of the variable
-       CHARACTER(LEN=*), DIMENSION(:) ::  val !< variable which should be read
-       
-       INTEGER(iwp) ::  id_mod   !< NetCDF id of input file
-
-#if defined ( __netcdf )
-!
-!--    Read variable
-       CALL get_variable( id_mod, search_string, val )
-#endif            
-
-    END SUBROUTINE netcdf_data_input_var_char
-    
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Read an 1D array of REAL values.
-!------------------------------------------------------------------------------!
-    SUBROUTINE netcdf_data_input_var_real_1d( val, search_string, id_mod )
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*) ::  search_string     !< name of the variable      
-       
-       INTEGER(iwp) ::  id_mod        !< NetCDF id of input file
-       
-       REAL(wp), DIMENSION(:) ::  val !< variable which should be read
-
-#if defined ( __netcdf )
-!
-!--    Read variable
-       CALL get_variable( id_mod, search_string, val )
-#endif            
-
-    END SUBROUTINE netcdf_data_input_var_real_1d
-    
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Read an 1D array of REAL values.
-!------------------------------------------------------------------------------!
-    SUBROUTINE netcdf_data_input_var_real_2d( val, search_string,              &
-                                              id_mod, d1s, d1e, d2s, d2e )
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*) ::  search_string     !< name of the variable     
-       
-       INTEGER(iwp) ::  id_mod  !< NetCDF id of input file
-       INTEGER(iwp) ::  d1e     !< end index of first dimension to be read
-       INTEGER(iwp) ::  d2e     !< end index of second dimension to be read
-       INTEGER(iwp) ::  d1s     !< start index of first dimension to be read
-       INTEGER(iwp) ::  d2s     !< start index of second dimension to be read
-       
-       REAL(wp), DIMENSION(:,:) ::  val !< variable which should be read
-
-#if defined ( __netcdf )
-!
-!--    Read character variable
-       CALL get_variable( id_mod, search_string, val, d1s, d1e, d2s, d2e )
-#endif            
-
-    END SUBROUTINE netcdf_data_input_var_real_2d
-    
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Read a global string attribute 
-!------------------------------------------------------------------------------!
-    SUBROUTINE netcdf_data_input_att_string( val, search_string, id_mod,       &
-                                             input_file, global, openclose,    &
-                                             variable_name )
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*) ::  search_string !< name of the attribue
-       CHARACTER(LEN=*) ::  val           !< attribute
-       
-       CHARACTER(LEN=*) ::  input_file    !< name of input file
-       CHARACTER(LEN=*) ::  openclose     !< string indicating whether NetCDF needs to be opend or closed
-       CHARACTER(LEN=*) ::  variable_name !< string indicating whether NetCDF needs to be opend or closed  
-       
-       INTEGER(iwp) ::  id_mod   !< NetCDF id of input file
-       
-       LOGICAL ::  global                 !< flag indicating a global or a variable's attribute
-
-#if defined ( __netcdf )
-!
-!--    Open file in read-only mode if necessary
-       IF ( openclose == 'open' )  THEN
-          CALL open_read_file( TRIM( input_file ) // TRIM( coupling_char ), &
-                                  id_mod )
-       ENDIF
-!
-!--    Read global attribute
-       IF ( global )  THEN
-          CALL get_attribute( id_mod, search_string, val, global )
-!
-!--    Read variable attribute
-       ELSE
-          CALL get_attribute( id_mod, search_string, val, global, variable_name )
-       ENDIF
-!
-!--    Close input file 
-       IF ( openclose == 'close' )  CALL close_input_file( id_mod )
-#endif            
-
-    END SUBROUTINE netcdf_data_input_att_string
-    
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Read a global 8-bit integer attribute 
-!------------------------------------------------------------------------------!
-    SUBROUTINE netcdf_data_input_att_int8( val, search_string, id_mod,         &
-                                           input_file, global, openclose,      &
-                                           variable_name )
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*) ::  search_string !< name of the attribue
-       
-       CHARACTER(LEN=*) ::  input_file    !< name of input file
-       CHARACTER(LEN=*) ::  openclose     !< string indicating whether NetCDF needs to be opend or closed
-       CHARACTER(LEN=*) ::  variable_name !< string indicating whether NetCDF needs to be opend or closed 
-       
-       INTEGER(iwp) ::  id_mod   !< NetCDF id of input file
-       INTEGER(KIND=1) ::  val      !< value of the attribute
-       
-       LOGICAL ::  global        !< flag indicating a global or a variable's attribute
-
-#if defined ( __netcdf )
-!
-!--    Open file in read-only mode
-       IF ( openclose == 'open' )  THEN
-          CALL open_read_file( TRIM( input_file ) // TRIM( coupling_char ), &
-                                  id_mod )
-       ENDIF
-!
-!--    Read global attribute
-       IF ( global )  THEN
-          CALL get_attribute( id_mod, search_string, val, global )
-!
-!--    Read variable attribute
-       ELSE
-          CALL get_attribute( id_mod, search_string, val, global, variable_name )
-       ENDIF
-!
-!--    Finally, close input file
-       IF ( openclose == 'close' )  CALL close_input_file( id_mod )
-#endif            
-
-    END SUBROUTINE netcdf_data_input_att_int8
-    
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Read a global 32-bit integer attribute 
-!------------------------------------------------------------------------------!
-    SUBROUTINE netcdf_data_input_att_int32( val, search_string, id_mod,        &
-                                            input_file, global, openclose,     &
-                                            variable_name )
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*) ::  search_string !< name of the attribue
-       
-       CHARACTER(LEN=*) ::  input_file    !< name of input file
-       CHARACTER(LEN=*) ::  openclose     !< string indicating whether NetCDF needs to be opend or closed
-       CHARACTER(LEN=*) ::  variable_name !< string indicating whether NetCDF needs to be opend or closed 
-       
-       INTEGER(iwp) ::  id_mod   !< NetCDF id of input file
-       INTEGER(iwp) ::  val      !< value of the attribute
-       
-       LOGICAL ::  global        !< flag indicating a global or a variable's attribute
-
-#if defined ( __netcdf )
-!
-!--    Open file in read-only mode
-       IF ( openclose == 'open' )  THEN
-          CALL open_read_file( TRIM( input_file ) // TRIM( coupling_char ), &
-                                  id_mod )
-       ENDIF
-!
-!--    Read global attribute
-       IF ( global )  THEN
-          CALL get_attribute( id_mod, search_string, val, global )
-!
-!--    Read variable attribute
-       ELSE
-          CALL get_attribute( id_mod, search_string, val, global, variable_name )
-       ENDIF
-!
-!--    Finally, close input file
-       IF ( openclose == 'close' )  CALL close_input_file( id_mod )
-#endif            
-
-    END SUBROUTINE netcdf_data_input_att_int32
-    
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Read a global real attribute 
-!------------------------------------------------------------------------------!
-    SUBROUTINE netcdf_data_input_att_real( val, search_string, id_mod,         &
-                                           input_file, global, openclose,      &
-                                           variable_name )
-
-       IMPLICIT NONE
-
-       CHARACTER(LEN=*) ::  search_string !< name of the attribue
-       
-       CHARACTER(LEN=*) ::  input_file    !< name of input file
-       CHARACTER(LEN=*) ::  openclose     !< string indicating whether NetCDF needs to be opend or closed
-       CHARACTER(LEN=*) ::  variable_name !< string indicating whether NetCDF needs to be opend or closed 
-       
-       INTEGER(iwp) ::  id_mod            !< NetCDF id of input file
-       
-       LOGICAL ::  global                 !< flag indicating a global or a variable's attribute
-       
-       REAL(wp) ::  val                   !< value of the attribute
-
-#if defined ( __netcdf )
-!
-!--    Open file in read-only mode
-       IF ( openclose == 'open' )  THEN
-          CALL open_read_file( TRIM( input_file ) // TRIM( coupling_char ), &
-                                  id_mod )
-       ENDIF
-!
-!--    Read global attribute
-       IF ( global )  THEN
-          CALL get_attribute( id_mod, search_string, val, global )
-!
-!--    Read variable attribute
-       ELSE
-          CALL get_attribute( id_mod, search_string, val, global, variable_name )
-       ENDIF
-!
-!--    Finally, close input file
-       IF ( openclose == 'close' )  CALL close_input_file( id_mod )
-#endif            
-
-    END SUBROUTINE netcdf_data_input_att_real
+
 
 !------------------------------------------------------------------------------!
@@ -5823,4 +5580,53 @@
 ! Description:
 ! ------------
+!> Inquires the _FillValue settings of an integer variable.
+!------------------------------------------------------------------------------!
+    SUBROUTINE inquire_fill_value_int( id, var_name, nofill, fill_value )
+#if defined( __netcdf )
+       CHARACTER(LEN=*), INTENT(IN) ::  var_name    !< variable name
+
+       INTEGER(iwp), INTENT(IN)  ::  id          !< file id
+       INTEGER(iwp)              ::  nofill      !< flag indicating whether fill values are set or not
+       INTEGER(iwp)              ::  fill_value  !< fill value
+       INTEGER(iwp)              ::  id_var      !< netCDF variable id (varid)
+
+       nc_stat = NF90_INQ_VARID( id, TRIM( var_name ), id_var )
+       nc_stat = NF90_INQ_VAR_FILL(id, id_var, no_fill, fill_value )
+#endif
+!
+!--    Further line is just to avoid compiler warnings. nofill might be used
+!--    in future.
+       IF ( nofill == 0  .OR.  nofill /= 0 )  CONTINUE
+
+    END SUBROUTINE inquire_fill_value_int
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Inquires the _FillValue settings of a real variable.
+!------------------------------------------------------------------------------!
+    SUBROUTINE inquire_fill_value_real( id, var_name, nofill, fill_value )
+#if defined( __netcdf )
+       CHARACTER(LEN=*), INTENT(IN) ::  var_name    !< variable name
+
+       INTEGER(iwp), INTENT(IN)  ::  id          !< file id
+       INTEGER(iwp)              ::  nofill      !< flag indicating whether fill values are set or not
+       INTEGER(iwp)              ::  id_var      !< netCDF variable id (varid)
+
+       REAL(wp), INTENT(OUT)     ::  fill_value  !< fill value
+
+       nc_stat = NF90_INQ_VARID( id, TRIM( var_name ), id_var )
+       nc_stat = NF90_INQ_VAR_FILL(id, id_var, no_fill, fill_value )
+#endif
+!
+!--    Further line is just to avoid compiler warnings. nofill might be used
+!--    in future.
+       IF ( nofill == 0  .OR.  nofill /= 0 )  CONTINUE
+
+    END SUBROUTINE inquire_fill_value_real
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
 !> Prints out a text message corresponding to the current status.
 !------------------------------------------------------------------------------!
